<copyright> ... for Apache TOM Module (ATM).
   Written by Pieter Schoenmakers <tiggr@gerbil.org>

   Copyright &copy; 1999 Pieter J. Schoenmakers.

   $Id$  </copyright>

<c>
#include <httpd.h>
</c>

implementation class
Request: State, OutputStream, Conditions

end;

implementation instance
Request
{
  <doc> The underlying {request_rec} that we cover.  </doc>
  pointer p;
}

<doc> Designated initializer.  </doc>
id (self)
  init pointer r
{
  p = r;
}

boolean (ho)
  header_only
{
  pointer r = p;
<c>
  ho = ((request_rec *) r)->header_only;
</c>
}

<doc> Send the http header.  </doc>
void
  send_http_header
{
  pointer r = p;
<c>
  ap_send_http_header (r);
</c>
}

<doc> Kill a timeout.  </doc>
void
  kill_timeout
{
  pointer r = p;
<c>
  ap_kill_timeout (r);
</c>
}

<doc> Start a soft timeout.  </doc>
void
  soft_timeout
{
  pointer r = p;
<c>
  ap_soft_timeout (r);
</c>
}

<doc> Set the content type (field {content_type}) of the request {r}.
    Since we can not guarantee smart things concerning the release of the
    request and the {String} that is passed, we only allow {"text/html"}
    and {"text/plain"}.  </doc>
boolean
  set_content_type String content_type
pre
  ([content_type equal "text/html"]
  || [content_type equal "text/plain"])
{
  boolean is_html = [content_type equal "text/html"];
  pointer r = p;

<c>
  ((request_rec *) r)->content_type = is_html ? "text/html" : "text/plain";
</c>
}

/******************** OutputStream ********************/

<doc> Write the byte {b}, signaling a condition upon eof.  </doc>
void
  write byte b
{
  pointer r = p;
  int n;
<c>
  n = ap_rputc (b, r);
</c>

  if (n < 0)
    [Runtime perror "ap_rputc" for self class stream-eos raise NO];
}

<doc> Write the byte {b} and return the number of bytes actually written
    (less than 0).  </doc>
int (n)
  write byte b
{
  pointer r = p;
<c>
  n = ap_rputc (b, r);
</c>
}

int (n)
  writeBytes int num
	from pointer address
{
  pointer r = p;
<c>
  n = ap_rwrite (address, num, r);
</c>
}

end;
