/* Generate constants for Apache TOM Module (ATM).
   Based on Apache 1.3.3 source code.
   Written by Pieter Schoenmakers <tiggr@gerbil.org>

   Copyright &copy; 1999 Pieter J. Schoenmakers.

   $Id$  */

#include <httpd.h>

#define DI(MACRO)  \
  printf ("  const " #MACRO " = %d;\n", MACRO)

int
main (int argc, char **argv)
{
  printf ("implementation class Constants\n{\n");

  /* From httpd.h.  */

  DI (APACHE_RELEASE);
  DI (DECLINED);
  DI (DONE);
  DI (OK);

  DI (HTTP_CONTINUE);
  DI (HTTP_SWITCHING_PROTOCOLS);
  DI (HTTP_PROCESSING);
  DI (HTTP_OK);
  DI (HTTP_CREATED);
  DI (HTTP_ACCEPTED);
  DI (HTTP_NON_AUTHORITATIVE);
  DI (HTTP_NO_CONTENT);
  DI (HTTP_RESET_CONTENT);
  DI (HTTP_PARTIAL_CONTENT);
  DI (HTTP_MULTI_STATUS);
  DI (HTTP_MULTIPLE_CHOICES);
  DI (HTTP_MOVED_PERMANENTLY);
  DI (HTTP_MOVED_TEMPORARILY);
  DI (HTTP_SEE_OTHER);
  DI (HTTP_NOT_MODIFIED);
  DI (HTTP_USE_PROXY);
  DI (HTTP_TEMPORARY_REDIRECT);
  DI (HTTP_BAD_REQUEST);
  DI (HTTP_UNAUTHORIZED);
  DI (HTTP_PAYMENT_REQUIRED);
  DI (HTTP_FORBIDDEN);
  DI (HTTP_NOT_FOUND);
  DI (HTTP_METHOD_NOT_ALLOWED);
  DI (HTTP_NOT_ACCEPTABLE);
  DI (HTTP_PROXY_AUTHENTICATION_REQUIRED);
  DI (HTTP_REQUEST_TIME_OUT);
  DI (HTTP_CONFLICT);
  DI (HTTP_GONE);
  DI (HTTP_LENGTH_REQUIRED);
  DI (HTTP_PRECONDITION_FAILED);
  DI (HTTP_REQUEST_ENTITY_TOO_LARGE);
  DI (HTTP_REQUEST_URI_TOO_LARGE);
  DI (HTTP_UNSUPPORTED_MEDIA_TYPE);
  DI (HTTP_RANGE_NOT_SATISFIABLE);
  DI (HTTP_EXPECTATION_FAILED);
  DI (HTTP_UNPROCESSABLE_ENTITY);
  DI (HTTP_LOCKED);
  DI (HTTP_INTERNAL_SERVER_ERROR);
  DI (HTTP_NOT_IMPLEMENTED);
  DI (HTTP_BAD_GATEWAY);
  DI (HTTP_SERVICE_UNAVAILABLE);
  DI (HTTP_GATEWAY_TIME_OUT);
  DI (HTTP_VERSION_NOT_SUPPORTED);
  DI (HTTP_VARIANT_ALSO_VARIES);
  DI (HTTP_NOT_EXTENDED);

  DI (M_GET);
  DI (M_PUT);
  DI (M_POST);
  DI (M_DELETE);
  DI (M_CONNECT);
  DI (M_OPTIONS);
  DI (M_TRACE);
  DI (M_INVALID);

  DI (REQUEST_NO_BODY);
  DI (REQUEST_CHUNKED_ERROR);
  DI (REQUEST_CHUNKED_DECHUNK);
  DI (REQUEST_CHUNKED_PASS);

  printf ("}\nend;\nimplementation instance Constants end;\n");

  return 0;
}
