/* Copyright (C) 1999 Pieter J. Schoenmakers <tiggr@gerbil.org>

   $Id$  */

#include <stdio.h>

#include <httpd.h>
#include <http_config.h>

#include "atm/atm-r.h"

#define tom_create_dir_config NULL	/* per-directory config creator */
#define tom_merge_dir_config NULL	/* dir config merger */
#define tom_create_server_config NULL	/* server config creator */
#define tom_merge_server_config NULL	/* server config merger */
#define tom_cmds NULL			/* command table */
#define tom_translate_handler NULL	/* [2] filename-to-URI translation */
#define tom_check_user_id NULL		/* [5] check/validate user_id */
#define tom_auth_checker NULL		/* [6] check user_id is valid *here* */
#define tom_access_checker NULL		/* [4] check access by host address */
#define tom_type_checker NULL		/* [7] MIME type checker/setter */
#define tom_fixer_upper NULL		/* [8] fixups */
#define tom_logger NULL			/* [10] logger */
#define tom_header_parser NULL		/* [3] header parser */
#define tom_child_init NULL		/* process initializer */
#define tom_child_exit NULL		/* process exit/cleanup */
#define tom_post_read_request NULL	/* [1] post read_request handling */

/* module initializer */
static void
tom_init  (server_rec *s, pool *p)
{
  char *argv_mock[] = {"apache-tom-module", 0};
  trt_init_main (1, argv_mock);
}

static int
tom_handler (request_rec *r)
{
  return TRT_SEND (, _mr_c_atm_ATM, SEL (i_handle_request_p), r);
}

/* [7] list of handlers */
static const handler_rec tom_handlers[] =
{
  {"atm", tom_handler},
  {}
};

module tom_module =
{
#define __FILE__ "atm"

    STANDARD_MODULE_STUFF,
    tom_init,			/* module initializer */
    tom_create_dir_config,	/* per-directory config creator */
    tom_merge_dir_config,	/* dir config merger */
    tom_create_server_config,	/* server config creator */
    tom_merge_server_config,	/* server config merger */
    tom_cmds,			/* command table */
    tom_handlers,		/* [7] list of handlers */
    tom_translate_handler,	/* [2] filename-to-URI translation */
    tom_check_user_id,		/* [5] check/validate user_id */
    tom_auth_checker,		/* [6] check user_id is valid *here* */
    tom_access_checker,		/* [4] check access by host address */
    tom_type_checker,		/* [7] MIME type checker/setter */
    tom_fixer_upper,		/* [8] fixups */
    tom_logger,			/* [10] logger */
#if MODULE_MAGIC_NUMBER >= 19970103
    tom_header_parser,		/* [3] header parser */
#endif
#if MODULE_MAGIC_NUMBER >= 19970719
    tom_child_init,		/* process initializer */
#endif
#if MODULE_MAGIC_NUMBER >= 19970728
    tom_child_exit,		/* process exit/cleanup */
#endif
#if MODULE_MAGIC_NUMBER >= 19970902
    tom_post_read_request	/* [1] post read_request handling */
#endif
};
